/* hack to enable libc-less project */

#include <stddef.h>

/* since we need to compile with -nodefaultlibs
   because of insufficient memory, we need to
   implement everything ourselves */

/* NOTE: NEVER RETURN FROM MAIN - THERE BE DRAGONS */

/* points to a reentrancy structure in libc;
   since we don't use the libc, point it to data memory,
   it will be overwritten later */
void* _impure_ptr = (void*)0x4000;

void exit(int code)
{
	while(1) __asm__ volatile("idle");
}

/* ================================================================== */

void *memcpy(void *dest, const void *src, size_t n)
{
	char *s = (char*)src;
	char *d = (char*)dest;

	while(n--) {
		*d++ = *s++;
	}

	return(dest);
}

void *memset(void *s, int c , size_t n)
{
	char *buf = (char*)s;

	while(n--) {
		*buf++ = (char)c;
	}

	return(s);
}

